'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Token = require('./Token');

var _Token2 = _interopRequireDefault(_Token);

var _illuminateJs = require('illuminate-js');

var _illuminateJs2 = _interopRequireDefault(_illuminateJs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var tokenize = _illuminateJs2.default.tokenize,
    getLanguage = _illuminateJs2.default.getLanguage;

var Illuminate = function (_Component) {
    _inherits(Illuminate, _Component);

    function Illuminate() {
        _classCallCheck(this, Illuminate);

        return _possibleConstructorReturn(this, (Illuminate.__proto__ || Object.getPrototypeOf(Illuminate)).apply(this, arguments));
    }

    _createClass(Illuminate, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps) {
            return this.props.children !== nextProps.children || this.props.lang !== nextProps.lang;
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                lang = _props.lang,
                children = _props.children;

            var token = children;

            var grammar = getLanguage(lang);

            if (grammar) {
                token = tokenize(children, grammar);
            }

            return _react2.default.createElement(
                'pre',
                { className: 'language-' + lang },
                _react2.default.createElement(
                    'code',
                    null,
                    _react2.default.createElement(_Token2.default, { token: token })
                )
            );
        }
    }]);

    return Illuminate;
}(_react.Component);

exports.default = Illuminate;